using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace VirtualGrid
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Form2 : System.Windows.Forms.Form
	{
		private VirtualGrid.UserControl1 userControl1;
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//turn off D&D support
			userControl1.GridControl1.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);

			userControl1.GridControl1.ResetVolatileData();
			userControl1.GridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			userControl1.GridControl1.QueryRowCount += new GridRowColCountEventHandler(GridQueryRowCount);
			//gridControl1.QueryCoveredRange += new GridQueryCellRangeEventHandler(GridQueryCoveredRange);
			userControl1.GridControl1.QueryRowHeight += new GridRowColSizeEventHandler(GridQueryRowHeight);
			userControl1.GridControl1.ColWidths[0] += 10;
			userControl1.GridControl1.Height = 6500;
			
			userControl1.GridControl2.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);

			userControl1.GridControl2.ResetVolatileData();
			userControl1.GridControl2.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			userControl1.GridControl2.QueryRowCount += new GridRowColCountEventHandler(GridQueryRowCount);
			//gridControl1.QueryCoveredRange += new GridQueryCellRangeEventHandler(GridQueryCoveredRange);
			userControl1.GridControl2.QueryRowHeight += new GridRowColSizeEventHandler(GridQueryRowHeight);
			userControl1.GridControl2.ColWidths[0] += 10;
			userControl1.GridControl2.Height = 6500;
			userControl1.TabControlAdv1.Height = 6500;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		void GridQueryRowCount(object sender, GridRowColCountEventArgs e) 
		{
			e.Count = 300;
			e.Handled = true;
		}

		void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e) 
		{
			if (e.RowIndex > 0)
			{
				if (e.ColIndex > 0)
				{
					if (e.ColIndex != 2)
						e.Style.CellValue = e.RowIndex.ToString() + "/" + e.ColIndex.ToString();

					if (e.RowIndex % 2 == 0)
					{
						e.Style.Interior = new BrushInfo(Color.FromArgb(0xED, 0xF0, 0xF7));
						e.Style.VerticalAlignment = GridVerticalAlignment.Bottom;
					}
					else
						e.Style.Interior = new BrushInfo(Color.FromArgb(0x91, 0xBB, 0xB8));

					if (e.ColIndex == 2)
					{
						if (e.RowIndex %2 == 0)
							e.Style.CellType = "PushButton";
						else
							e.Style.CellType = "DropDownGrid";
						e.Style.Description = "Click";
					}
					else
						e.Style.CellType = "Static";

					if (e.RowIndex % 4 == 0)
						e.Style.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, Color.Orange, GridBorderWeight.Medium);
				}
				e.Handled = true;
			}
		}


		void GridQueryRowHeight(object sender, GridRowColSizeEventArgs e) 
		{
			if (e.Index % 2 == 0)
			{
				e.Size = 25;
				e.Handled = true;
			}
		}

		void GridQueryCoveredRange(object sender, GridQueryCoveredRangeEventArgs e) 
		{
			if (e.RowIndex % 2 == 1 && e.ColIndex >= 1 && e.ColIndex <= 3)
			{
				e.Range = GridRangeInfo.Cells(e.RowIndex, 1, e.ColIndex, 3);
				e.Handled = true;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				userControl1.GridControl1.QueryCellInfo -= new GridQueryCellInfoEventHandler(GridQueryCellInfo);
				userControl1.GridControl1.QueryRowCount -= new GridRowColCountEventHandler(GridQueryRowCount);
				//userControl1.GridControl1.QueryCoveredRange -= new GridQueryCoveredRangeEventHandler(GridQueryCoveredRange);
				userControl1.GridControl1.QueryRowHeight -= new GridRowColSizeEventHandler(GridQueryRowHeight);

				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

    #region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.userControl1 = new VirtualGrid.UserControl1();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// userControl1
			// 
			this.userControl1.AutoScroll = true;
			this.userControl1.Location = new System.Drawing.Point(16, 8);
			this.userControl1.Name = "userControl1";
			this.userControl1.Size = new System.Drawing.Size(528, 472);
			this.userControl1.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 488);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(520, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Select Any cell in the top grid, scroll down to the grid contained in the tab control and select a cell. Alternatively select a cell in the grid contained in the tab control and then scroll up and select any cell in the top grid. (The scrollbar jumps to the top)";
			// 
			// Form2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 535);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.userControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form2";
			this.Text = "Form2";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
